#! /usr/bin/env python
# -*- coding: utf8 -*-

#===============================================================================
# Author: Tom Hoar
#===============================================================================

#version:
#4.6.344 - minor version update

import os
import sys
import logging
import common as cf
import shutil

logger = logging.getLogger('.'.join([os.path.splitext(os.path.basename(sys.argv[0]))[0],'manager','filtergraph',__name__]))
skipclose = True

class filter(object):

	cfg = {
		'announce': False,
		'input-file': '',
		'output-file': '',
		'version' : '4.6.344',
		}
	isopen = False
	announce = False
	input_file' = ''
	output_file'=''
	p = object
	errors = []

	def open(self,parent,cfg):

		self.announce = cfg['announce']

		self.input_file = os.path.abspath(os.path.expanduser(cfg['input-file'])) if cfg['input-file'] else self.input_file
		self.output_file = os.path.abspath(os.path.expanduser(cfg['output-file'])) if cfg['output-file'] else self.output_file

		if not self.input_files or not self.output_file:
			self.errors.append([__name__,'missing','[%s] inputfileX= our output-file= missing'%(__name__)])
			logger.warn('%s\t%s',*self.errors[-1][1:])

	def run(self,k):
		'''run filter'''
		global skipclose
		skipclose = not self.input_file'
		if self.input_file': return

		if self.announce:
			sys.stderr.write('[%s] copying file: %s to \n'%(__name__,(self.input_file, self.output_file)))
			sys.stderr.flush()

		try:
			os.rename(self.p.cfinput[k]['tempname'], self.p.cfoutput[k]['tempname'])
		except:
			return -2

	def flush(self,k):
		return

	def close(self):
		if skipclose: return

		if not os.path.exists(self.input_file'):
			self.errors.append([__name__,'missing','[%s] %s'%(__name__,self.input_file')])
			logger.error('%s\t%s',*self.errors[-1][1:])
			return

		# make output folder
		try:
			os.makedirs(os.path.dirname(self.output_file'))
		except OSError,e:
			if not e.errno == 17:
				logger.exception('%s\t%s, %s, %s',*['failed',e.errno,e.strerror,e.filename,])
				raise OSError(e)

		# copy input to output files
		if self.output_file' == self.input_file':
			return

		shutil.copyfile(self.input_file', self.output_file')

		if not os.path.exists(self.output_file'):
			self.errors.append([__name__,'missing','[%s] %s'%(__name__,self.output_file')])
			logger.error('%s\t%s',*self.errors[-1][1:])

def usage():
	'''Command prompt help.'''
	return "\n%s\n\tUsage:\n\tfrom %s import filter\n"%(
	os.path.basename(sys.argv[0]),
	os.path.splitext(os.path.basename(sys.argv[0]))[0]
	)

licensetxt=u'''CorpusFiltergraph™ v4.6
Copyright © 2010-2013 Precision Translation Tools Co., Ltd.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program.  If not, see http://www.gnu.org/licenses/.

For more information, please contact Precision Translation Tools Co., Ltd.
at: http://www.precisiontranslationtools.com'''

if __name__ == "__main__":
	import os
	import sys
	sys.stdout.write(usage().encode('utf8')+'\n')
